package de.tudarmstadt.informatik.hostage.format;

/**
 * Interface for log view formatter.
 * This class provides functionality to format the presentation of specific protocols.
 * @author Wulf Pfeiffer
 */
public interface ProtocolFormatter {

	/**
	 * Formats the content of packet. The packet content can be a normal String or a hexadecimal String,
	 * depending of the type of the protocol. ByteArray protocols receive hexdecimal String, else normal Strings.
	 * @param packet that should be formatted.
	 * @return new format of the packet content.
	 */
	String format(String packet);
}
