package de.tudarmstadt.informatik.hostage.io;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.io.OutputStreamWriter;
import java.util.List;

/**
 * Handles the reading and writing of the socket in- and outputstream for strings
 * @author Mihai Plasoianu
 */
public class StringReaderWriter implements ReaderWriter<String> {

	private BufferedReader in;
	private BufferedWriter out;

	/**
	 * Constructor
	 * @param in inputstream
	 * @param out outputstream
	 */
	public StringReaderWriter(InputStream in, OutputStream out) {
		this.in = new BufferedReader(new InputStreamReader(in));
		this.out = new BufferedWriter(new OutputStreamWriter(out));

	}

	
	public String read() throws IOException {
		return in.readLine();
	}

	
	public void write(List<String> message) throws IOException {
		for (String m : message) {
			out.write(m + "\n");
			out.flush();
		}
	}

}
