package de.tudarmstadt.informatik.hostage.protocol;

import javax.net.ssl.SSLContext;
/**
 * Interface for ssl protocols that are used by hostage
 * @author Wulf Pfeiffer
 * @param <T> Denotes if the protocol is using Strings or ByteArrays
 */
public interface SSLProtocol<T> extends Protocol<T> {

	/**
	 * Returns the initialized SSL Context with the KeyManager and TrustManager that will be used
	 * @return the used SSLContext
	 */
	SSLContext getSSLContext();
}
